var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
(function(global, factory) {
  typeof exports === "object" && typeof module !== "undefined" ? factory(exports, require("react"), require("react-dom"), require("viewerjs")) : typeof define === "function" && define.amd ? define(["exports", "react", "react-dom", "viewerjs"], factory) : (global = typeof globalThis !== "undefined" ? globalThis : global || self, factory(global.viewerjs_react = {}, global.React, global.ReactDOM, global.Viewerjs));
})(this, function(exports2, React, ReactDOM, Viewerjs) {
  "use strict";
  function _interopDefaultLegacy(e) {
    return e && typeof e === "object" && "default" in e ? e : { "default": e };
  }
  function _interopNamespace(e) {
    if (e && e.__esModule)
      return e;
    var n = { __proto__: null, [Symbol.toStringTag]: "Module" };
    if (e) {
      Object.keys(e).forEach(function(k) {
        if (k !== "default") {
          var d = Object.getOwnPropertyDescriptor(e, k);
          Object.defineProperty(n, k, d.get ? d : {
            enumerable: true,
            get: function() {
              return e[k];
            }
          });
        }
      });
    }
    n["default"] = e;
    return Object.freeze(n);
  }
  var React__namespace = /* @__PURE__ */ _interopNamespace(React);
  var ReactDOM__default = /* @__PURE__ */ _interopDefaultLegacy(ReactDOM);
  var Viewerjs__default = /* @__PURE__ */ _interopDefaultLegacy(Viewerjs);
  function useMountedState() {
    var mountedRef = React.useRef(false);
    var get = React.useCallback(function() {
      return mountedRef.current;
    }, []);
    React.useEffect(function() {
      mountedRef.current = true;
      return function() {
        mountedRef.current = false;
      };
    }, []);
    return get;
  }
  var useEffectOnce = function(effect) {
    React.useEffect(effect, []);
  };
  var useMount = function(fn) {
    useEffectOnce(function() {
      fn();
    });
  };
  var useUnmount = function(fn) {
    var fnRef = React.useRef(fn);
    fnRef.current = fn;
    useEffectOnce(function() {
      return function() {
        return fnRef.current();
      };
    });
  };
  const ImageList = React__namespace.forwardRef(({
    imageUrls,
    imageListClassname,
    showImageList,
    style,
    customImageListComponent,
    title
  }, refOut) => {
    const ref = React__namespace.useRef(null);
    const disableShowStyle = React__namespace.useMemo(() => {
      if (!showImageList) {
        return {
          height: "0px",
          overflow: "hidden"
        };
      }
      return {};
    }, [showImageList]);
    const mountState = useMountedState();
    React__namespace.useImperativeHandle(refOut, () => ({
      getMountState: () => mountState(),
      getInnerRef: () => ref.current
    }));
    return customImageListComponent ? React__namespace.cloneElement(customImageListComponent, { ref }) : /* @__PURE__ */ React__namespace.createElement("ul", {
      ref,
      className: imageListClassname,
      style: __spreadValues(__spreadValues({}, style), disableShowStyle)
    }, imageUrls && imageUrls.length > 0 && imageUrls.map((imageUrl, index) => {
      let alt = "";
      if (Array.isArray(title)) {
        try {
          alt = title[index];
        } catch (error) {
          console.warn("title array size is not match image array size");
        }
      } else if (typeof title === "string") {
        alt = title;
      }
      return /* @__PURE__ */ React__namespace.createElement("li", null, /* @__PURE__ */ React__namespace.createElement("img", {
        src: imageUrl,
        key: imageUrl,
        alt
      }));
    }));
  });
  ImageList.displayName = "ImageList";
  var events = { exports: {} };
  var R = typeof Reflect === "object" ? Reflect : null;
  var ReflectApply = R && typeof R.apply === "function" ? R.apply : function ReflectApply2(target, receiver, args) {
    return Function.prototype.apply.call(target, receiver, args);
  };
  var ReflectOwnKeys;
  if (R && typeof R.ownKeys === "function") {
    ReflectOwnKeys = R.ownKeys;
  } else if (Object.getOwnPropertySymbols) {
    ReflectOwnKeys = function ReflectOwnKeys2(target) {
      return Object.getOwnPropertyNames(target).concat(Object.getOwnPropertySymbols(target));
    };
  } else {
    ReflectOwnKeys = function ReflectOwnKeys2(target) {
      return Object.getOwnPropertyNames(target);
    };
  }
  function ProcessEmitWarning(warning) {
    if (console && console.warn)
      console.warn(warning);
  }
  var NumberIsNaN = Number.isNaN || function NumberIsNaN2(value) {
    return value !== value;
  };
  function EventEmitter() {
    EventEmitter.init.call(this);
  }
  events.exports = EventEmitter;
  events.exports.once = once;
  EventEmitter.EventEmitter = EventEmitter;
  EventEmitter.prototype._events = void 0;
  EventEmitter.prototype._eventsCount = 0;
  EventEmitter.prototype._maxListeners = void 0;
  var defaultMaxListeners = 10;
  function checkListener(listener) {
    if (typeof listener !== "function") {
      throw new TypeError('The "listener" argument must be of type Function. Received type ' + typeof listener);
    }
  }
  Object.defineProperty(EventEmitter, "defaultMaxListeners", {
    enumerable: true,
    get: function() {
      return defaultMaxListeners;
    },
    set: function(arg) {
      if (typeof arg !== "number" || arg < 0 || NumberIsNaN(arg)) {
        throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received ' + arg + ".");
      }
      defaultMaxListeners = arg;
    }
  });
  EventEmitter.init = function() {
    if (this._events === void 0 || this._events === Object.getPrototypeOf(this)._events) {
      this._events = Object.create(null);
      this._eventsCount = 0;
    }
    this._maxListeners = this._maxListeners || void 0;
  };
  EventEmitter.prototype.setMaxListeners = function setMaxListeners(n) {
    if (typeof n !== "number" || n < 0 || NumberIsNaN(n)) {
      throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received ' + n + ".");
    }
    this._maxListeners = n;
    return this;
  };
  function _getMaxListeners(that) {
    if (that._maxListeners === void 0)
      return EventEmitter.defaultMaxListeners;
    return that._maxListeners;
  }
  EventEmitter.prototype.getMaxListeners = function getMaxListeners() {
    return _getMaxListeners(this);
  };
  EventEmitter.prototype.emit = function emit(type) {
    var args = [];
    for (var i = 1; i < arguments.length; i++)
      args.push(arguments[i]);
    var doError = type === "error";
    var events2 = this._events;
    if (events2 !== void 0)
      doError = doError && events2.error === void 0;
    else if (!doError)
      return false;
    if (doError) {
      var er;
      if (args.length > 0)
        er = args[0];
      if (er instanceof Error) {
        throw er;
      }
      var err = new Error("Unhandled error." + (er ? " (" + er.message + ")" : ""));
      err.context = er;
      throw err;
    }
    var handler = events2[type];
    if (handler === void 0)
      return false;
    if (typeof handler === "function") {
      ReflectApply(handler, this, args);
    } else {
      var len = handler.length;
      var listeners = arrayClone(handler, len);
      for (var i = 0; i < len; ++i)
        ReflectApply(listeners[i], this, args);
    }
    return true;
  };
  function _addListener(target, type, listener, prepend) {
    var m;
    var events2;
    var existing;
    checkListener(listener);
    events2 = target._events;
    if (events2 === void 0) {
      events2 = target._events = Object.create(null);
      target._eventsCount = 0;
    } else {
      if (events2.newListener !== void 0) {
        target.emit("newListener", type, listener.listener ? listener.listener : listener);
        events2 = target._events;
      }
      existing = events2[type];
    }
    if (existing === void 0) {
      existing = events2[type] = listener;
      ++target._eventsCount;
    } else {
      if (typeof existing === "function") {
        existing = events2[type] = prepend ? [listener, existing] : [existing, listener];
      } else if (prepend) {
        existing.unshift(listener);
      } else {
        existing.push(listener);
      }
      m = _getMaxListeners(target);
      if (m > 0 && existing.length > m && !existing.warned) {
        existing.warned = true;
        var w = new Error("Possible EventEmitter memory leak detected. " + existing.length + " " + String(type) + " listeners added. Use emitter.setMaxListeners() to increase limit");
        w.name = "MaxListenersExceededWarning";
        w.emitter = target;
        w.type = type;
        w.count = existing.length;
        ProcessEmitWarning(w);
      }
    }
    return target;
  }
  EventEmitter.prototype.addListener = function addListener(type, listener) {
    return _addListener(this, type, listener, false);
  };
  EventEmitter.prototype.on = EventEmitter.prototype.addListener;
  EventEmitter.prototype.prependListener = function prependListener(type, listener) {
    return _addListener(this, type, listener, true);
  };
  function onceWrapper() {
    if (!this.fired) {
      this.target.removeListener(this.type, this.wrapFn);
      this.fired = true;
      if (arguments.length === 0)
        return this.listener.call(this.target);
      return this.listener.apply(this.target, arguments);
    }
  }
  function _onceWrap(target, type, listener) {
    var state = { fired: false, wrapFn: void 0, target, type, listener };
    var wrapped = onceWrapper.bind(state);
    wrapped.listener = listener;
    state.wrapFn = wrapped;
    return wrapped;
  }
  EventEmitter.prototype.once = function once2(type, listener) {
    checkListener(listener);
    this.on(type, _onceWrap(this, type, listener));
    return this;
  };
  EventEmitter.prototype.prependOnceListener = function prependOnceListener(type, listener) {
    checkListener(listener);
    this.prependListener(type, _onceWrap(this, type, listener));
    return this;
  };
  EventEmitter.prototype.removeListener = function removeListener(type, listener) {
    var list, events2, position, i, originalListener;
    checkListener(listener);
    events2 = this._events;
    if (events2 === void 0)
      return this;
    list = events2[type];
    if (list === void 0)
      return this;
    if (list === listener || list.listener === listener) {
      if (--this._eventsCount === 0)
        this._events = Object.create(null);
      else {
        delete events2[type];
        if (events2.removeListener)
          this.emit("removeListener", type, list.listener || listener);
      }
    } else if (typeof list !== "function") {
      position = -1;
      for (i = list.length - 1; i >= 0; i--) {
        if (list[i] === listener || list[i].listener === listener) {
          originalListener = list[i].listener;
          position = i;
          break;
        }
      }
      if (position < 0)
        return this;
      if (position === 0)
        list.shift();
      else {
        spliceOne(list, position);
      }
      if (list.length === 1)
        events2[type] = list[0];
      if (events2.removeListener !== void 0)
        this.emit("removeListener", type, originalListener || listener);
    }
    return this;
  };
  EventEmitter.prototype.off = EventEmitter.prototype.removeListener;
  EventEmitter.prototype.removeAllListeners = function removeAllListeners(type) {
    var listeners, events2, i;
    events2 = this._events;
    if (events2 === void 0)
      return this;
    if (events2.removeListener === void 0) {
      if (arguments.length === 0) {
        this._events = Object.create(null);
        this._eventsCount = 0;
      } else if (events2[type] !== void 0) {
        if (--this._eventsCount === 0)
          this._events = Object.create(null);
        else
          delete events2[type];
      }
      return this;
    }
    if (arguments.length === 0) {
      var keys = Object.keys(events2);
      var key;
      for (i = 0; i < keys.length; ++i) {
        key = keys[i];
        if (key === "removeListener")
          continue;
        this.removeAllListeners(key);
      }
      this.removeAllListeners("removeListener");
      this._events = Object.create(null);
      this._eventsCount = 0;
      return this;
    }
    listeners = events2[type];
    if (typeof listeners === "function") {
      this.removeListener(type, listeners);
    } else if (listeners !== void 0) {
      for (i = listeners.length - 1; i >= 0; i--) {
        this.removeListener(type, listeners[i]);
      }
    }
    return this;
  };
  function _listeners(target, type, unwrap) {
    var events2 = target._events;
    if (events2 === void 0)
      return [];
    var evlistener = events2[type];
    if (evlistener === void 0)
      return [];
    if (typeof evlistener === "function")
      return unwrap ? [evlistener.listener || evlistener] : [evlistener];
    return unwrap ? unwrapListeners(evlistener) : arrayClone(evlistener, evlistener.length);
  }
  EventEmitter.prototype.listeners = function listeners(type) {
    return _listeners(this, type, true);
  };
  EventEmitter.prototype.rawListeners = function rawListeners(type) {
    return _listeners(this, type, false);
  };
  EventEmitter.listenerCount = function(emitter, type) {
    if (typeof emitter.listenerCount === "function") {
      return emitter.listenerCount(type);
    } else {
      return listenerCount.call(emitter, type);
    }
  };
  EventEmitter.prototype.listenerCount = listenerCount;
  function listenerCount(type) {
    var events2 = this._events;
    if (events2 !== void 0) {
      var evlistener = events2[type];
      if (typeof evlistener === "function") {
        return 1;
      } else if (evlistener !== void 0) {
        return evlistener.length;
      }
    }
    return 0;
  }
  EventEmitter.prototype.eventNames = function eventNames() {
    return this._eventsCount > 0 ? ReflectOwnKeys(this._events) : [];
  };
  function arrayClone(arr, n) {
    var copy = new Array(n);
    for (var i = 0; i < n; ++i)
      copy[i] = arr[i];
    return copy;
  }
  function spliceOne(list, index) {
    for (; index + 1 < list.length; index++)
      list[index] = list[index + 1];
    list.pop();
  }
  function unwrapListeners(arr) {
    var ret = new Array(arr.length);
    for (var i = 0; i < ret.length; ++i) {
      ret[i] = arr[i].listener || arr[i];
    }
    return ret;
  }
  function once(emitter, name) {
    return new Promise(function(resolve, reject) {
      function errorListener(err) {
        emitter.removeListener(name, resolver);
        reject(err);
      }
      function resolver() {
        if (typeof emitter.removeListener === "function") {
          emitter.removeListener("error", errorListener);
        }
        resolve([].slice.call(arguments));
      }
      eventTargetAgnosticAddListener(emitter, name, resolver, { once: true });
      if (name !== "error") {
        addErrorHandlerIfEventEmitter(emitter, errorListener, { once: true });
      }
    });
  }
  function addErrorHandlerIfEventEmitter(emitter, handler, flags) {
    if (typeof emitter.on === "function") {
      eventTargetAgnosticAddListener(emitter, "error", handler, flags);
    }
  }
  function eventTargetAgnosticAddListener(emitter, name, listener, flags) {
    if (typeof emitter.on === "function") {
      if (flags.once) {
        emitter.once(name, listener);
      } else {
        emitter.on(name, listener);
      }
    } else if (typeof emitter.addEventListener === "function") {
      emitter.addEventListener(name, function wrapListener(arg) {
        if (flags.once) {
          emitter.removeEventListener(name, wrapListener);
        }
        listener(arg);
      });
    } else {
      throw new TypeError('The "emitter" argument must be of type EventEmitter. Received type ' + typeof emitter);
    }
  }
  var EventEmitter$1 = events.exports;
  const eventEmitter = new EventEmitter$1();
  const eventType = {
    ready: "ready"
  };
  const ViewerJsReact = React__namespace.forwardRef(({
    customImageListComponent,
    customToolbar,
    imageUrls = [],
    showImageList,
    imageListClassname,
    viewerjsOptions = {},
    extraComponent,
    onInit,
    onReady,
    onShown,
    onViewed,
    onBeforeClose,
    onAfterClose
  }, ref) => {
    const viewer = React__namespace.useRef();
    const currentImageDetail = React__namespace.useRef();
    const imageListRef = React__namespace.useRef({ getInnerRef: () => null, getMountState: () => false });
    const renderCustomToolbar = React__namespace.useRef(false);
    const renderExtraComponent = React__namespace.useRef(false);
    React__namespace.useEffect(() => {
      eventEmitter.addListener(eventType.ready, () => {
        if (customToolbar && !renderCustomToolbar.current && viewer.current) {
          const viewContainer = document.querySelector(".viewer-container");
          if (viewContainer) {
            const divContainer = document.createElement("div");
            ReactDOM__default["default"].render(customToolbar, viewContainer.appendChild(divContainer));
            renderCustomToolbar.current = true;
          }
        }
        if (extraComponent && !renderExtraComponent.current && viewer.current) {
          const viewContainer = document.querySelector(".viewer-container");
          if (viewContainer) {
            const divContainer = document.createElement("div");
            ReactDOM__default["default"].render(extraComponent, viewContainer.appendChild(divContainer));
            renderExtraComponent.current = true;
          }
        }
      });
    }, [customToolbar, extraComponent]);
    React__namespace.useImperativeHandle(ref, () => ({
      getViewer: () => viewer.current,
      getCurrentImageDetail: () => currentImageDetail.current
    }));
    React__namespace.useEffect(() => {
      const flag = imageUrls.some((url) => !!url);
      if (viewer.current && flag) {
        viewer.current.update();
      }
    }, [
      imageUrls
    ]);
    useMount(() => {
      if (imageListRef.current.getMountState()) {
        const innerRef = imageListRef.current.getInnerRef();
        if (innerRef) {
          if (onBeforeClose) {
            innerRef.addEventListener("hide", () => {
              onBeforeClose();
            });
          }
          if (onAfterClose) {
            innerRef.addEventListener("hidden", () => {
              onAfterClose();
            });
          }
          innerRef.addEventListener("view", (event) => {
            if (event && event.detail) {
              currentImageDetail.current = event.detail;
            }
          });
          viewer.current = new Viewerjs__default["default"](innerRef, __spreadProps(__spreadValues({
            toolbar: !customToolbar
          }, viewerjsOptions), {
            ready() {
              eventEmitter.emit(eventType.ready);
              if (onReady) {
                onReady();
              }
            },
            shown() {
              if (onShown) {
                onShown();
              }
            },
            viewed() {
              if (onViewed) {
                onViewed();
              }
            }
          }));
          if (onInit) {
            onInit();
          }
        }
      }
    });
    useUnmount(() => {
      if (viewer.current) {
        viewer.current.destroy();
        eventEmitter.removeAllListeners();
      }
    });
    return /* @__PURE__ */ React__namespace.createElement(ImageList, {
      ref: imageListRef,
      imageUrls,
      showImageList: !!showImageList,
      imageListClassname,
      customImageListComponent
    });
  });
  ViewerJsReact.displayName = "ViewerJsReact";
  React__namespace.memo(ViewerJsReact);
  exports2.ViewerJsReact = ViewerJsReact;
  exports2.eventEmitter = eventEmitter;
  exports2.eventType = eventType;
  Object.defineProperty(exports2, "__esModule", { value: true });
  exports2[Symbol.toStringTag] = "Module";
});
